<?php
class Calendarista_TimeslotController extends Calendarista_BaseController{
	private $repo;
	private $timeslot;
	public function __construct($timeslot, $createCallback = null, $updateCallback = null, $deleteCallback = null){
		if (!(array_key_exists('controller', $_POST) 
			&& $_POST['controller'] == 'calendarista_timeslot')){
			return;
		}
		$this->timeslot = $timeslot;
		$this->repo = new Calendarista_TimeslotRepository();
		parent::__construct($createCallback, $updateCallback, $deleteCallback);
	}
	public function create($callback){
		$result = false;
		$duplicate = false;
		if($this->timeslot->weekday === -1){
			$timeslots = $this->repo->readSingleDayByAvailability($this->timeslot->day->format(CALENDARISTA_DATEFORMAT), $this->timeslot->availabilityId, $this->timeslot->returnTrip);
		}else{
			$timeslots = $this->repo->readAllByWeekday($this->timeslot->weekday, $this->timeslot->availabilityId, $this->timeslot->returnTrip);
		}
		foreach($timeslots as $timeslot){
			if($this->timeslot->timeslot === $timeslot->timeslot && $this->timeslot->returnTrip == $timeslot->returnTrip){
				$duplicate = true;
				break;
			}
		}
		if(!$duplicate){
			$result = $this->repo->insert($this->timeslot);
			if($result !== false){
				$this->timeslot->id = $result;
			}
		}
		$this->executeCallback($callback, array($duplicate, $result));
	}
	public function update($callback){
		$result = false;
		$duplicate = false;
		if(!$this->timeslot->weekday){
			$timeslots = $this->repo->readSingleDayByAvailability($this->timeslot->day->format(CALENDARISTA_DATEFORMAT), $this->timeslot->availabilityId, $this->timeslot->returnTrip);
		}else{
			$timeslots = $this->repo->readAllByWeekday($this->timeslot->weekday, $this->timeslot->availabilityId, $this->timeslot->returnTrip);
		}
		foreach($timeslots as $timeslot){
			if($this->timeslot->id !== $timeslot->id && ($this->timeslot->timeslot === $timeslot->timeslot && $this->timeslot->returnTrip == $timeslot->returnTrip)){
				$duplicate = true;
				break;
			}
		}
		if(!$duplicate){
			$result = $this->repo->update($this->timeslot);
		}
		$this->executeCallback($callback, array($duplicate, $result));
	}
	public function delete($callback){
		$result = $this->repo->delete($this->timeslot->id);
		$this->executeCallback($callback, array($result));
	}
}
?>