<?php
class Calendarista_ReminderList extends Calendarista_List {
	public $totalPages;
	public $currentPage;
	public $perPage;
	public $orderBy;
	public $count;
	function __construct( ){
		$this->perPage = 10;
        parent::__construct( array(
            'singular'  => 'order', 
            'plural'    => 'orders', 
            'ajax'      => false    
        ) );
    }
	
	function single_row( $item ) {
		static $row_class = '';
		$row_class = ( $row_class == '' ? 'alternate' : '' );
		$id = isset($_POST['id']) ? (int)$_POST['id'] : null;
		if($item['id'] == $id){
			$row_class .= ' table-selected-row';
		}
		$row_class = $row_class ? ' class="' . $row_class . '"' : '';
		echo '<tr' . $row_class . '>';
		echo $this->single_row_columns( $item );
		echo '</tr>';
	}
	
    function column_default($item, $column_name){
        switch($column_name){
            default:
                return print_r($item,true); 
        }
    }
    
	function column_id($item){
		return $item['id'];
	}
	function column_orderId($item){
		return $item['orderId'];
	}
	function column_sentDate($item){
		return Calendarista_TimeHelper::formatDate($item['sentDate']);
	}
	function column_fullName($item){
		return  $item['fullName'] ? $item['fullName'] : '--';
	}
	function column_email($item){
		return $item['email'];
	}
	
	function column_action($item){
		$buttonGroups = array();
		array_push($buttonGroups, sprintf(
			'<li>
				<button class="button button-primary" name="resend" title="%s">
					<i class="fa-regular fa-paper-plane"></i> 
				</button>
			</li>'
			, __('Send reminder again.', 'calendarista')
		));
		array_push($buttonGroups, sprintf(
			'<li>
				<button class="button button-primary" name="delete" title="%s">
					<i class="fa fa-remove"></i> 
				</button>
			</li>'
			, __('Delete this reminder.', 'calendarista')
		));
        return sprintf(
			'<form action="%s" method="post">
				<input type="hidden" name="controller" value="calendarista_reminders" />
				<input type="hidden" name="id" value="%d" />
				<input type="hidden" name="projectId" value="%d"/>
				<input type="hidden" name="orderId" value="%d"/>
				<input type="hidden" name="bookedAvailabilityId" value="%d"/>
				<ul class="action-list">%s</ul>
			</form>'
			, $_SERVER['REQUEST_URI']
			, $item['id']
			, $item['projectId']
			, $item['orderId']
			, $item['bookedAvailabilityId']
			, join("\n", $buttonGroups)
        );
	}
	
    function get_columns(){
        $columns = array(
			'id'=>__('ID', 'calendarista')
			, 'orderId'=>__('ORDER ID', 'calendarista')
			, 'sentDate'=>__('SENT DATE', 'calendarista')
            , 'fullName'=>__('NAME', 'calendarista')
			, 'email'=>__('EMAIL', 'calendarista')
			, 'action'=>__('ACTION', 'calendarista')
        );
        return $columns;
    }
    
    /**
		@description binds to data
	*/
    function bind() {
        
        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        
        $this->_column_headers = array($columns, $hidden, $sortable);
        $currentPage = $this->get_pagenum() - 1;
		if( $currentPage ){
			$currentPage = $currentPage * $this->perPage;
		}

        $this->orderBy = (!empty($_REQUEST[$this->orderByKey])) ? $_REQUEST[$this->orderByKey] : 'id';
        $this->order = (!empty($_REQUEST[$this->orderKey])) ? $_REQUEST[$this->orderKey] : 'desc'; 
		$remindersRepository = new Calendarista_RemindersRepository();
        $result = $remindersRepository->readAll($currentPage, $this->perPage, $this->orderBy, $this->order);
        $this->count = $result->total;
        $this->items = $result->toArray();
		if(!$this->count){
			return;
		}
		$this->totalPages = ceil($result->total / $this->perPage);
        $this->set_pagination_args( array(
            'total_items' => $this->count,
            'per_page'    => $this->perPage,
            'total_pages' => $this->totalPages
        ) );
    }
	
	function get_table_classes() {
		return array('wp-list-table', 'calendarista',  'widefat', 'fixed', 'striped');
	}
}
?>